zero_length_keys.sh 3.8 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120
  1. #!/bin/sh
  2. # Check that tor regenerates keys when key files are zero-length
  3. # Test for bug #13111 - Tor fails to start if onion keys are zero length
  4. #
  5. # Usage:
  6. # ./zero_length_keys.sh
  7. # Run all the tests below
  8. # ./zero_length_keys.sh -z
  9. # Check tor will launch and regenerate zero-length keys
  10. # ./zero_length_keys.sh -d
  11. # Check tor regenerates deleted keys (existing behaviour)
  12. # ./zero_length_keys.sh -e
  13. # Check tor does not overwrite existing keys (existing behaviour)
  14. #
  15. # Exit Statuses:
  16. # 0: test succeeded - tor regenerated/kept the files
  17. # 1: test failed - tor did not regenerate/keep the files
  18. # 2: test failed - tor did not generate the key files on first run
  19. # 3: a command failed - the test could not be completed
  20. #
  21. if [ $# -lt 1 ]; then
  22. echo "Testing that tor correctly handles zero-length keys"
  23. "$0" -z && "$0" -d && "$0" -e
  24. exit $?
  25. fi
  26. DATA_DIR=`mktemp -d -t tor_zero_length_keys.XXXXXX`
  27. if [ -z "$DATA_DIR" ]; then
  28. echo "Failure: mktemp invocation returned empty string" >&2
  29. exit 3
  30. fi
  31. if [ ! -d "$DATA_DIR" ]; then
  32. echo "Failure: mktemp invocation result doesn't point to directory" >&2
  33. exit 3
  34. fi
  35. trap "rm -rf '$DATA_DIR'" 0
  36. touch "$DATA_DIR"/empty_torrc
  37. # DisableNetwork means that the ORPort won't actually be opened.
  38. # 'ExitRelay 0' suppresses a warning.
  39. TOR="./src/or/tor --hush --DisableNetwork 1 --ShutdownWaitLength 0 --ORPort 12345 --ExitRelay 0 -f $DATA_DIR/empty_torrc"
  40. if [ -s "$DATA_DIR"/keys/secret_id_key ] && [ -s "$DATA_DIR"/keys/secret_onion_key ] &&
  41. [ -s "$DATA_DIR"/keys/secret_onion_key_ntor ]; then
  42. echo "Failure: Previous tor keys present in tor data directory" >&2
  43. exit 3
  44. else
  45. echo "Generating initial tor keys"
  46. $TOR --DataDirectory "$DATA_DIR" --list-fingerprint
  47. # tor must successfully generate non-zero-length key files
  48. if [ -s "$DATA_DIR"/keys/secret_id_key ] && [ -s "$DATA_DIR"/keys/secret_onion_key ] &&
  49. [ -s "$DATA_DIR"/keys/secret_onion_key_ntor ]; then
  50. true #echo "tor generated the initial key files"
  51. else
  52. echo "Failure: tor failed to generate the initial key files"
  53. exit 2
  54. fi
  55. fi
  56. #ls -lh "$DATA_DIR"/keys/ || exit 3
  57. # backup and keep/delete/create zero-length files for the keys
  58. FILE_DESC="keeps existing"
  59. # make a backup
  60. cp -r "$DATA_DIR"/keys "$DATA_DIR"/keys.old
  61. # delete keys for -d or -z
  62. if [ "$1" != "-e" ]; then
  63. FILE_DESC="regenerates deleted"
  64. rm "$DATA_DIR"/keys/secret_id_key || exit 3
  65. rm "$DATA_DIR"/keys/secret_onion_key || exit 3
  66. rm "$DATA_DIR"/keys/secret_onion_key_ntor || exit 3
  67. fi
  68. # create empty files for -z
  69. if [ "$1" = "-z" ]; then
  70. FILE_DESC="regenerates zero-length"
  71. touch "$DATA_DIR"/keys/secret_id_key || exit 3
  72. touch "$DATA_DIR"/keys/secret_onion_key || exit 3
  73. touch "$DATA_DIR"/keys/secret_onion_key_ntor || exit 3
  74. fi
  75. echo "Running tor again to check if it $FILE_DESC keys"
  76. $TOR --DataDirectory "$DATA_DIR" --list-fingerprint
  77. #ls -lh "$DATA_DIR"/keys/ || exit 3
  78. # tor must always have non-zero-length key files
  79. if [ -s "$DATA_DIR"/keys/secret_id_key ] && [ -s "$DATA_DIR"/keys/secret_onion_key ] &&
  80. [ -s "$DATA_DIR"/keys/secret_onion_key_ntor ]; then
  81. # check if the keys are different to the old ones
  82. diff -q -r "$DATA_DIR"/keys "$DATA_DIR"/keys.old > /dev/null
  83. SAME_KEYS=$?
  84. # if we're not testing existing keys,
  85. # the current keys should be different to the old ones
  86. if [ "$1" != "-e" ]; then
  87. if [ $SAME_KEYS -ne 0 ]; then
  88. echo "Success: test that tor $FILE_DESC key files: different keys"
  89. exit 0
  90. else
  91. echo "Failure: test that tor $FILE_DESC key files: same keys"
  92. exit 1
  93. fi
  94. else #[ "$1" == "-e" ]; then
  95. if [ $SAME_KEYS -eq 0 ]; then
  96. echo "Success: test that tor $FILE_DESC key files: same keys"
  97. exit 0
  98. else
  99. echo "Failure: test that tor $FILE_DESC key files: different keys"
  100. exit 1
  101. fi
  102. fi
  103. else
  104. echo "Failure: test that tor $FILE_DESC key files: no key files"
  105. exit 1
  106. fi